<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_schedule".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticeSchedule".
 *
 * Columns in table "provider_practice_schedule" available as properties of the model,
 * followed by relations of table "provider_practice_schedule" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_practice_id
 * @property integer $day_number
 * @property string $hours
 * @property integer $is_generated
 *
 * @property ProviderPractice $providerPractice
 */
abstract class BaseProviderPracticeSchedule extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_schedule';
    }

    public static function representingColumn()
    {
        return 'day_number';
    }

    public function rules()
    {
        return array(
            array('provider_practice_id, day_number', 'required'),
            array('provider_practice_id, day_number, is_generated', 'numerical', 'integerOnly' => true),
            array('hours', 'length', 'max' => 50),
            array('hours, is_generated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_practice_id, day_number, hours, is_generated', 'safe', 'on' => 'search'),
            array(
                'hours',
                'match',
                'pattern' => '/(^((0|1)\d|2[0-3])[:][0-5]\d[:][0-5]\d[ ][-][ ]((0|1)\d|2[0-3])[:][0-5]\d[:][0-5]\d$)/',
                'message' => 'Please enter a valid hour range'
            )
        );
    }

    public function relations()
    {
        return array(
            'providerPractice' => array(self::BELONGS_TO, 'ProviderPractice', 'provider_practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_practice_id' => Yii::t('app', 'Provider and Practice'),
            'day_number' => Yii::t('app', 'Weekday'),
            'hours' => Yii::t('app', 'Hours'),
            'is_generated' => Yii::t('app', 'Is Generated'),
            'providerPractice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;
        $criteria->with = array('providerPractice', 'providerPractice.provider', 'providerPractice.practice');

        if (!intval($this->provider) && is_string($this->provider) && strlen($this->provider) > 0) {
            $criteria->compare('provider.first_last', $this->provider, true);
        } else {
            $criteria->compare('provider_id', $this->provider);
        }
        if (!intval($this->practice) && is_string($this->practice) && strlen($this->practice) > 0) {
            $criteria->compare('practice.name', $this->practice, true);
        } else {
            $criteria->compare('practice_id', $this->practice);
        }

        $criteria->compare('day_number', $this->day_number);
        $criteria->compare('hours', $this->hours, true);
        $criteria->compare('is_generated', $this->is_generated);

        $sort = new CSort();
        $sort->attributes = array(
            'provider' => array(
                'asc' => 'provider.first_last',
                'desc' => 'provider.first_last desc',
            ),
            'practice' => array(
                'asc' => 'practice.name',
                'desc' => 'practice.name desc',
            ),
        );
        $sort->defaultOrder = 'provider.first_last';

        return new CActiveDataProvider(get_class($this), array('criteria' => $criteria, 'pagination' => array('pageSize' => 100), 'sort' => $sort));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticeSchedule|ProviderPracticeSchedules', $n);
    }

}
